\ AutoU.fth Taqoz V2.8 Tools
\ By CWE

{
   AutoL with toset and Locals in LUT
   AutoM 5.11.22 offsets for local variables corrected
   AutoN 19.12.2022 More Space for User Data
   AutoU 10.10.23 With chain
   
\ to Autoload, if P40=0  (keys pin on startup:

VAR chainFlag
12 table chain$

" auto.f" chain$ $!
1 chainFlag !

: aload \ gives pause for stop and possibility to chain
   crlf ." ESC ESC for stop"
   4000 ms
   begin
   key@ $FFFF and $1B1B <> \ not esc esc pressed
   \ 40 pin@ 0= and 
   chainFlag @ and while
      0 chainFlag !
      chain$ FOPEN$ if @FILE FLOADS then
   repeat
;

!INITS

' aload +INIT

BACKUP BIX

}


.s
%red %pen

IFDEF *CeTools*	
    \ oldCeTOrg org
    !polls
    1 cogstop
    FORGET *CeTools*  }

pub *CeTools*	PRINT" CeTools AutoU.fth CWE " ;

\ 0 bytes oldCeTOrg

org@ := oriorg
$6C000 := userdata
userdata org
!polls \ clear multitasking                           
4 cogstop \ display
5 cogstop \ Fifo Files
6 cogstop \ adcDac

%white %pen

\ Thanks to Bob Edwards
pre ALIAS
 [C] NFA' [G] ?DUP
 IF ( nfa )
--- read cfa then create new header & store cfa in its cpa
 DUP C@ $E0 AND SWAP CFA ( atrs cfa )
 [C] CREATE$
--- blend old atrs in with new count (also patch 230309)
 OVER @WORDS C@ OR @WORDS C!
--- then store the CFA into the new CPA as 2 or 3 bytes (atr.5)
 @WORDS CPA ROT $20 AND IF M! ELSE W! THEN
 ELSE ERROR
 THEN
;

\ : cells 4* ;

ALIAS 4* cells

: LutMod_Library ; \ { ====================================================

168 := lutStart
long lutPC
lutStart lutPC ! \ depends on usage of L-stack, which starts at $80 128dez

512 lutStart - longs lutCode \ holds copy of lut code for additional cogs

long startPC   long endPC

FORTH ASSEMBLER
: getStart \ directive: get the start of a routine
   _pc @ startPC !
;
: getEnd \ directive: get the end of a routine
   _pc @ endPC !
;
FORTH


: mov2Lut \ move the last routine to LUT
   startPC @
   begin
      dup @ 
      dup lutPC @ lut! \ copy code to this cog
      lutPC @ lutStart - cells lutCode + ! \ copy to HUB too
      lutPC ++
      4 +
   dup endPC @ => until
   drop
;

: getLutCode \ for new cog: copy lutCode to lut
   lutStart
   begin
      dup lutStart - cells lutCode + @ \ get from HUB
      over lut!
      1+
   dup lutPC @ > until
;
      

{ \ example
create$ fiboLutAsm lutPC @ 512 + @words CPA W!
code fiboAsm ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
       mov xx,#0
       mov yy,#1
       mov zz,#0
       FOR:
          mov xx,yy
          mov yy,zz
          add zz,xx
       NEXT: a
   _ret_    mov a,zz
   getEnd
end
mov2Lut

46 lap fiboAsm lap . .lap
46 lap fiboLutAsm lap . .lap

}
\ }

: Variables_Library ; \ { #################################################


\ { Create and Does by Bob Edwards ########################################

--- create new dev with dummy cfa (save ptr to it)
pub CREATE ( -- )
    [C] GRAB
    [C] CREATE: --- Using the next word in the input stream as the name, create a VARIABLE type dictionary entry
    [C] GRAB --- make sure CREATE: has run before anything more
    HERE 2- 0 REG W! --- save the address of the code after DOES> in the REG scratchpad area
;
--- set new cfa to point back to DOES: code (skipped by DOES: itself)
pub DOES> ( -- )
    R> --- the first word location in the new word being defined
    0 REG W@ --- retrieve the address stored on scratchpad
    W! --- set the first word to execute as the address of the code after DOES>
;


{ --- example definition of a new 'array of words' data type - no bounds checking
pre WARRAY
    CREATE ( cnt -- )
    FOR
        0 [C] ||
    NEXT --- Create cnt bytes set to 0
    DOES> ( index -- addr )
        2* R> + --- the address of the first byte + index = the entry reqd
;
--- Create a new array MARRAY1 which can hold 10 word size values
10 WARRAY MYARRAY1
}

\ }

pre ARRAY
    CREATE ( cnt -- )
    FOR
        0 [C] ,
    NEXT --- Create cnt bytes set to 0
    DOES> ( index -- addr )
        4* R> + --- the address of the first byte + index = the entry reqd
;

\ { Lut Variables ###############################################

long lutOrg \ Pointer to next free pos
$1ff lutOrg !

pre lutLongs ( n <name> ) \ create n longs private for each cpu in LUT
     create 
         lutOrg @ swap - \ decrement pointer
         dup 1+ [C] ,
         lutOrg !
     does> ( -- address )
        R> @
;

\ }


\ { Value variable type ########################################## 


pre cpuVar ( <name> ) \ create private long variable=0 for each cpu
     create 
        8 FOR
            0 [C] ,
        NEXT --- Create 8 longs set to 0
     does> ( -- address )
        R> cogid 4* + 
;

\ Variant with lutLong
1 lutLongs tosetL
0 tosetL LUT! \ don't forget for new cog

create$ to lutPC @ 512 + @words CPA W!
code (to)
   getStart
   mov r2,#tosetL
   mov r3,#1
   _ret_ wrlut r3,r2
   getEnd
end
mov2Lut

create$ +to lutPC @ 512 + @words CPA W!
code (+to)
   getStart
   mov r2,#tosetL
   mov r3,#2
   _ret_ wrlut r3,r2
   getEnd
end
mov2Lut

: to?
   tosetL dup . lut@ . ;

create$ (value) lutPC @ 512 + @words CPA W!
code ((value)) ( [newvalue] Adress -- ) '\ checks toset, 0: read, 1: store, 2: +=
   getStart
            mov r2,#tosetL
            rdlut r0,r2 wz  '\ get toset
    if_z    rdlong a,a  '\ get the value
    if_z    ret
            cmp r0,#1 wz    '\ check for store
            mov r0,#0   '\ clear toset
            wrlut r0,r2
    if_z    wrlong b,a  '\ store the new value
    if_z    jmp #\@2DROP     

            rdlong r1,a  '\ get the oldvalue
            add r1,b     '\ add newvalue
            wrlong r1,a  '\ store the value
            jmp #\@2DROP 
   getEnd
end
mov2Lut

pre value ( beim Anlegen wird Wert abgelegt, nach to: Wert ueberschreiben, )
    ( +to addieren, sonst wird Wert auf den Stack gelegt )
    create 
    [C] ,
    does> 
        R>
        (value)
; 



( 25 value foo )
( foo . )

\ } Value Variable 





: Locals_Library ; ( { simple locals Library ############################ )

$15 =: auxptr \ pointer in cog of L> auxstack


\ Fast Locals, in COG RAM

\ new cog registers for locals 
489 := acm
488 := bcm
487 := ccm
486 := dcm
485 := ecm

code cLoc ' \ make room for new locals on L-Stack
      wrlut ecm,auxptr
      add auxptr,#1
      wrlut dcm,auxptr
      add auxptr,#1
      wrlut ccm,auxptr
      add auxptr,#1
      wrlut bcm,auxptr
      add auxptr,#1
      wrlut acm,auxptr
   _ret_ add auxptr,#1
end

code cEndloc ' \ restore the ones from calling from L-Stack
      sub auxptr,#1 
      rdlut acm,auxptr
      sub auxptr,#1
      rdlut bcm,auxptr      
      sub auxptr,#1
      rdlut ccm,auxptr
      sub auxptr,#1
      rdlut dcm,auxptr
      sub auxptr,#1
   _ret_ rdlut ecm,auxptr
end

$086 := PUSHX

create$ >a lutPC @ 512 + @words CPA W!
code (>a) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov acm,a ' \ >a
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ +>a lutPC @ 512 + @words CPA W!
code (+>a) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   add acm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ a> lutPC @ 512 + @words CPA W!
code (a>) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov xx,acm ' \ a>
   jmp #\PUSHX
   getEnd
end
mov2Lut

create$ >b lutPC @ 512 + @words CPA W!
code (>b) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov bcm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ +>b lutPC @ 512 + @words CPA W!
code (+>b) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   add bcm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ b> lutPC @ 512 + @words CPA W!
code (b>) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov xx,bcm ' 
   jmp #\PUSHX
   getEnd
end
mov2Lut

create$ >c lutPC @ 512 + @words CPA W!
code (>c) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov ccm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ +>c lutPC @ 512 + @words CPA W!
code (+>c) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   add ccm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ c> lutPC @ 512 + @words CPA W!
code (c>) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov xx,ccm ' 
   jmp #\PUSHX
   getEnd
end
mov2Lut

create$ >d lutPC @ 512 + @words CPA W!
code (>d) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov dcm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ +>d lutPC @ 512 + @words CPA W!
code (+>d) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   add dcm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ d> lutPC @ 512 + @words CPA W!
code (d>) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov xx,dcm ' 
   jmp #\PUSHX
   getEnd
end
mov2Lut

create$ >e lutPC @ 512 + @words CPA W!
code (>e) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov ecm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ +>e lutPC @ 512 + @words CPA W!
code (+>e) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   add ecm,a ' 
   jmp #\@DROP
   getEnd
end
mov2Lut

create$ e> lutPC @ 512 + @words CPA W!
code (e>) ( n1 -- f ) '\ n2=n1'th fibonacci number
   getStart
   mov xx,ecm ' 
   jmp #\PUSHX
   getEnd
end
mov2Lut


( Adapted from: https://atariage.com/forums/topic/273092-forth-local-variables-for-the-common-man/ )
\ Mark Wills: http://turboforth.net/resources/simple_locals.html


: loc cLoc nop ; ( put 0 locals into local stack. loc_ geht nicht ! )
: loc_a cLoc >a ; ( put 1 locals into local stack )
: loc_a_b cLoc >b >a ; ( put 2 locals into local stack )
: loc_a_b_c cLoc >c >b >a ; ( put 3 locals into local stack )
: loc_a_b_c_d cLoc >d >c >b >a ; ( put 4 locals into local stack )
: loc_a_b_c_d_e cLoc >e >d >c >b >a ; ( put 5 locals into local stack )
{ \ Examples
: testlocal loc_a_b_c ( a b c -- n ) a> b> - c> * cEndloc ;
( 5 2 7 testlocal . )

: fiboCogLocals cLoc ( n -- f ) \ forth words for locals as inline code in lut
    0 >a   1 >b   0 >c
    ( n ) for
        b> >a
        c> >b
        a> +>c
    next
    c> 
cEndloc ;

46 lap fiboCogLocals lap . .lap
}    


\ } Locals

\ } Variables_Library

: NamedLocals_Library ; ( { named locals Library ############################ )

\ https://www.complang.tuwien.ac.at/forth/gforth/Docs-html/Locals.html#Locals

\ pre ALIAS	[C] NFA' [G] DUP CFA [C] CREATE$ @WORDS CPA!   C@ $E0 AND @WORDS C+! ;

5 array loc>CFAs
nfa' a> cfa 0 loc>CFAs !
nfa' b> cfa 1 loc>CFAs !
nfa' c> cfa 2 loc>CFAs !
nfa' d> cfa 3 loc>CFAs !
nfa' e> cfa 4 loc>CFAs !

5 array >locCFAs
nfa' >a cfa 0 >locCFAs !
nfa' >b cfa 1 >locCFAs !
nfa' >c cfa 2 >locCFAs !
nfa' >d cfa 3 >locCFAs !
nfa' >e cfa 4 >locCFAs !

5 array +>locCFAs
nfa' +>a cfa 0 +>locCFAs !
nfa' +>b cfa 1 +>locCFAs !
nfa' +>c cfa 2 +>locCFAs !
nfa' +>d cfa 3 +>locCFAs !
nfa' +>e cfa 4 +>locCFAs !

nfa' >a c@ $E0 AND [G] := locType \ type of word for locals

25 bytes nextName$
byte nextChar#
long locStat#   \ status
long locStack#  \ number of locals from stack
long locNum#    \ total number of locals
long names#
long startName#
long lenName#

' cEndloc := endlocCFA
' cLoc := locCFA
' loc_a := loc_a_CFA
' loc_a_b := loc_b_CFA
' loc_a_b_c := loc_c_CFA
' loc_a_b_c_d := loc_d_CFA
' loc_a_b_c_d_e := loc_e_CFA

: initLoc \ allocate stack frame and initalize locals
    locStack# @ switch
        1 case locCFA [C] || break   
        2 case loc_a_CFA [C] || break
        3 case loc_b_CFA [C] || break
        4 case loc_c_CFA [C] || break
        5 case loc_d_CFA [C] || break
        6 case loc_e_CFA [C] || break       
; 

\ $BC REG @ .l

long startName#
long lenName#
: createTo \ create the brother to_Name
   @words c@ lenName# ! \ old length
   @words lenName# @ 6 + - startName# !
   116 1 startName# @ + c!
   111 2 startName# @ + c!
   95 3 startName# @ + c!
   lenName# @ for \ copy Name
      @words 1+ i + c@
      startName# @ 4 + i + c!
   next
   startName# @ $BC REG ! \ move @ words
   lenName# @ 3 + @words c! \ longer by to_
;

: create+To \ create the brother +to_Name
   @words c@ lenName# ! \ old length
   @words lenName# @ 4 + - startName# !
   43 1 startName# @ + c! \ +
   lenName# @ for \ copy Name
      @words 1+ i + c@
      startName# @ 2 + i + c!
   next
   startName# @ $BC REG ! \ move @ words
   lenName# @ 1 + @words c! \ longer by +
;
   
pre {: ( -- ) \ locals Syntax {: initLocal1 initLocal2 ... , nonInitLocal ... -- comment } 
    0 locStat# !    1 locStack# !   1 locNum# ! 
    names @ names# ! \ preserve names pointer
    begin
        wkey nextChar# c!
        \ crlf nextChar# c@ dup . emit locStat# @ . @words .long
            nextChar# c@ ',' = if \ end of initialised locals
                3 locStat# ! 
                nextChar# c@ emit
            else
                nextChar# c@ '-' = if \ end of locals, start of comment
                    1 locStat# ! 
                    nextChar# c@ emit
                else
                    nextChar# c@ '}' = if \ end of comment
                        2 locStat# !  
                        nextChar# c@ emit
                    else
                        locStat# @ 0 =   locStat# @ 3 = or if
                            nextChar# c@ key! \ write back to buffer
                            [C] CREATE$ \ create the alias name entry 
                            locNum# @ 1 - loc>CFAs @   @WORDS CPA!
                            \ locType @WORDS C+! not necessary
                            createTo 
                            locNum# @ 1 - >locCFAs @   @WORDS CPA!
                            create+To 
                            locNum# @ 1 - +>locCFAs @   @WORDS CPA!
                        then
                        locStat# @ 0 = if
                            1 locNum# +!
                            1 locStack# +!
                        then
                        locStat# @ 3 = if
                            1 locNum# +!
                        then  
                        locStat# @ 1 = if
                            nextChar# c@ emit
                        then 
                    then
                then
            then 
    locStat# @ 2 = until
    initLoc \ allocate stack frame and load locals
; \ }        


pre forgetLocals names# @ names ! ;

pre (;) \ new definition for named locals
    locNum# @ if         
        endlocCFA [C] [W] \ free stack frame
        0 locNum# ! 
        \ [C] forgetLocals \ forget the new local names 
    then
    [C] ; 
;

alias (;) ;


\ Examples:

{
: ltest2 {: rolf ina , sum -- summe } \ 2 locals initialized , 3 locals total 
    rolf . ina . rolf ina + to_sum
    sum . \ ( was not initialised from stack ) onto stack
; forgetLocals


: fiboLocals {: n , a b c -- f }
    0 to_a   1 to_b   0 to_c
    n for
        b to_a
        c to_b
        a +to_c
    next
    c 
; forgetLocals
46 lap fiboLocals lap . .lap

\ forgetLocals


: printSum {: numberL# , sumL# -- } \ 1 locals initialized , 2 locals total 
   0 to sumL#
   numberL# 1+ 0 do 
      i sumL# + to_sumL#
   loop
   sumL# .
;



: inbds ( testval lowLimit hiLimit -- false_true ) \ traditional
    3RD >
    rot rot \ to get the first result out of the way 
    > and 
; 

: inbounds {: testval lowLimit hiLimit -- false_true } \ with named locals
    testval lowLimit >  
    testval hiLimit <   AND 
;

: lta {: num# }
    num# . ;


}
   
\ }


: MemInfo_Library ; \ { #################################################################

--- checks whether cog n is idle (idle=1) or busy (idle=0) Bob Edwards
code COGIDLE                        ( n -- idle )
    cogid a wc
    if_c mov a #0
    if_nc mov a #1
    ret
end

: .cogs ( -- ) \ print the words running in cogs
   8 0 do
      crlf i . space 
      i cogidle if 
         ." idle"
      else
         i task w@ ?dup if 
            cfa>nfa .nfa 
         else
            ." code"
         then
      then
   loop
;

: .memscan \ print contents of memory
    crlf ." Memory scan: (1k)"
    $8.0000 0 do
        crlf+ i .l space
        $8000 0 do
            j i + @ dup 
            0 = if ." 0" drop
            else
                $0E0E0E0E = if ." v" \ Video
                else ." X" then
            then
        $400 +loop       
    $8000 +loop
;

: .memo \ print memory information
    .USAGE
    crlf+ ." Code:      " 0 .l ."  to " here .l
    crlf+ ." Words:     " @words .l ."  to " " END" SEARCH 6 + .l
    crlf+ ." Video:     " BMP .l ."  to " 
        SCR scrsz + .l
    crlf+ 
    crlf+ ." Original Data:   " $1800 .l ."  to " oriorg .l
    crlf+ ." User Data:       " userdata .l ."  to " org@ .l    
    crlf+ ." RX Buffer Start: " $7f500 .l
    crlf+ ." SD:              " sdbuf .l ."  to End"
    .memscan
;

\ .memo

\ } MemInfo_Library

: Misc_Library ; \ { ###############################################################


: 8b {: long# , result# -- result# } \ convert to 8bits
   0 to_result#
   8 for
      long# 2 // i << +to_result#
      long# 10 / to_long#
   next
   result#
; forgetLocals


\ { Time ###############################################################

: time! ( hhmmss -- ) \ recalculate and set boot time
    HMS 60 * + 60 * + btime !
    getms bms !
;
 
: time@ ( -- hhmmss )
    qtime@ 240000 // ;

: time.
    qtime@ 240000 // .
;

: date.
    bdate @ . ;

value oldvtime#
: vtd. \ print time and date to vga
    time@ oldvtime# <> if
        time@ to oldvtime#
        500 5 vxy vga date. time. emit;
    then
;

\ } TIME

: page ( -- ) ( { clear ANSI terminal page )
    27 emit 91 emit
    50 emit
    74 emit
    0 0 %XY
; ( } )


: %savePos \ save cursor position
    27 emit 55 emit ;

: %restorePos \ restore cursor position
    27 emit 56 emit ;

: ttd. \ print time and date to terminal
    time@ oldvtime# <> if
        time@ to oldvtime#
        %savePos
        80 0 %xy date. time. 
        %restorePos
    then
;


\ slow gettext gett.fth 
{ 
pre GETTEXT \ End: Euro or ESC
    [C] FOPEN
    @FILE 0= IF 
        1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE OVER SDC! 1+ 
    REPEAT
    DROP 0 SWAP SDC! FCLOSE
;
}


\ { fast gettext #####################################

\ fast variant of SAVETEXT for longer text, has to wait for SD-card
\ Usage: RW gettext file.fth This is the text ESC

SCR := textbuf \ was $6c000 

: getbuf ( -- length )
    0 BEGIN WKEY 
        DUP emit
        DUP $1B <> \ esc
        over 128 <> and \ Euro
    WHILE 
        OVER textbuf + C! 1+ 
    REPEAT
    drop 
    0 over textbuf + C! 
    1+
;

: .buffer
    0
    crlf
    begin
        dup textbuf + c@
    dup while
        emit 1+
    repeat
    drop
    crlf . ." Bytes " crlf
;

\ long sdpause

pre GETTEXT \ Usage: RW gettext AUTO.F This is the text ESC
    RW [C] FOPEN
    @FILE 0= IF 
        RW 1 MB MAKE file$ FOPEN$ 0EXIT 
    THEN 
   !POLLS    
    getbuf 
    \ sdpause ~
    ( length ) 0 do
        i textbuf + c@
        i sdc!
        \ sdpause dup ++ @ 510 > if sdpause ~ 2 ms then 
    loop
    FCLOSE
;

: GETAUTO \ overwrite auto.f and reboot
   RW " AUTO.F" fopen$ 0exit
   crlf ."  auto.f? " crlf
   !polls
   getbuf
   ( length ) 0 do
        i textbuf + c@
        i sdc!
    loop
    FCLOSE
    reboot
;  



\ } fast gettext


\ { Heart Beat Polling ############################################################

: outsec \ copies time bit to pin 57 ( led of Kiss board )
    getms 9 >> 1 and 57 pin!
;
\ !polls \ clear polling tasks

\ ' outsec +poll \ funktioniert

\ } Polling
    
\ } Misc_Library 

: toInit
   0 tosetL LUT! ;

\ Don't forget to include getLutCode and toInit, when starting a cog!!!



8 BPP 360p !VGA 
VGA 'A' EMIT -mono emit;
vclr

\ ' dcfSet 1 run

!polls

\ ' vtd. +poll
\ ' ttd. +poll

\ " auto1.f" chain$ $!    1 chainFlag !  aload
\ fload auto1.f
